package sysinfo

import "encoding/json"

type SensorsCollector struct{}

func (SensorsCollector) SectionKey() string { return "sensors" }

func (SensorsCollector) EnsurePrerequisites(pm PackageManager, _ *Context) error {
	if pm.Distro() == "ubuntu" {
		return pm.InstallPackages("lm-sensors")
	}
	return nil
}

func (SensorsCollector) IsSupported(pm PackageManager, _ *Context) bool {
	return pm.ExecExists("sensors")
}

func (SensorsCollector) CollectData(c *Context) (json.RawMessage, error) {
	return json.Marshal(map[string]string{
		"output": c.SafeRun("sensors"),
	})
}
